* SOS * 

;-----------------------------------------------------------------
;
;		Damier 4096 couleurs
;
;		Oriens/HAWK 1992
;
;-----------------------------------------------------------------

	Bsr put_plans
	Bsr Construit_damier

;	MOVE.L	#$2e8135C1,$8E(A6)	; 
;	MOVE.L	#$003800D0,$92(A6)	; 40



;---------------------------------------------------------------
;---------------------------------------------------------------
;---------------------------------------------------------------
Damier:
	Bsr	Fill_Board

	add.w	#1,tempo
	cmp.w	#3,tempo
	bne	no_anim
	clr.w	tempo

	Bsr	scroll_damier
	Bsr	Anim_board
Rts
;---------------------------------------------------------------
;	Routine damier
;---------------------------------------------------------------
Scroll_damier:
	lea	table_couleur+[60*2],a0
	lea	table_couleur,a1

	clr.l	d0
	clr.l	d1

	move.w	#13,d1
scroll_b2:
	move.l	a0,a2
	move.l	a1,a3
	
	move.w	#59,d0
scroll_b1:
	move.w	(a2)+,(a3)+
	dbra	d0,scroll_b1

	add.l	#60*2,a0
	add.l	#60*2,a1
	dbra	d1,scroll_b2
	Rts
;---------------------------------------------------------------
Compteur_ligne:	dc.w	0
;---------------------------------------------------------------
Anim_board:
	clr.l	d0
	move.w	compteur_ligne,d0

	lea	motif,a0
	
	cmp.w	#$ffff,(a0,d0.w)
	bne	ok_go_anim1

	move.w	#0,compteur_ligne
	bra	anim_board
ok_go_anim1:
	add.l	d0,a0	

	lea	table_couleur+[120*14],a2
	move.l	a0,a1
	move.l	a2,a3

	clr.l	d1
	move.w	#59,d1
fill_a1:
	move.w	(a1)+,(a3)+
	dbra	d1,fill_a1

	add.w	#[60*2],compteur_ligne
	Rts
;---------------------------------------------------------------
Motif:		; par lignes de 60
	blk.w	[60]*[86],0
        dc.w	$ffff
;---------------------------------------------------------------
tempo:	dc.w	0
;---------------------------------------------------------------
Module:
	dc.l	Table_couleur			; addresse de la table
	dc.l	60				; modulo
	dc.l	table_couleur			; restart
;---------------------------------------------------------------
Fill_board:
	lea	module,a0
	move.l	(a0),a1

	move.w	#14,fade_coef
	lea	l1+6,a2
	bsr	Fill_ligne2

	move.w	#12,fade_coef
	lea	l2+6,a2
	bsr	Fill_ligne2

	move.w	#10,fade_coef
	lea	l3+6,a2
	bsr	Fill_ligne2

	move.w	#8,fade_coef
	lea	l4+6,a2
	bsr	Fill_ligne2

	move.w	#6,fade_coef
	lea	l5+6,a2
	bsr	Fill_ligne2

	move.w	#4,fade_coef
	lea	l6+6,a2
	bsr	Fill_ligne2

	move.w	#3,fade_coef
	lea	l7+6,a2
	bsr	Fill_ligne2

	move.w	#2,fade_coef
	lea	l8+6,a2
	bsr	Fill_ligne2

	move.w	#1,fade_coef
	lea	l9+6,a2
	bsr	Fill_ligne2

	lea	l10+6,a2
	bsr	Fill_ligne1

	lea	l11+6,a2
	bsr	Fill_ligne1

	lea	l12+6,a2
	bsr	Fill_ligne1

	lea	l13+6,a2
	bsr	Fill_ligne1

	Rts
;---------------------------------------------------------------
fill_ligne1:			; sans fade et toute la ligne
	clr.l	d0
	move.w	#29,d0
fill_b1:
	move.w	(a1)+,(a2)
	addq	#4,a2
	dbra	d0,fill_b1

	add.l	4(a0),a1	; plus modulo
	Rts
;---------------------------------------------------------------
fill_ligne2:			; plus fade et toute la ligne
	clr.l	d0
	move.w	#29,d0
fill_b2:
	move.w	(a1)+,d1	; d1>(a2)

	bsr	fade_in

	move.w	d1,(a2)

	addq	#4,a2
	dbra	d0,fill_b2

	add.l	4(a0),a1	; plus modulo
	Rts
;---------------------------------------------------------------
fade_ok:	dc.w	0
fade_coef:	dc.w	0
;---------------------------------------------------------------
fade_in:
	move.w	d1,d2

	and.w	#$f,d2
	sub.w	fade_coef,d2
	bpl	no_zero1
	clr.w	d2
no_zero1:
	and.w	#$ff0,d1
	or.w	d2,d1

	move.w	d1,d2
	lsr	#4,d2
	and.w	#$f,d2
	sub.w	fade_coef,d2
	bpl	no_zero2
	clr.w	d2
no_zero2:
	and.w	#$f0f,d1
	lsl	#4,d2
	or.w	d2,d1

	move.w	d1,d2

	lsr	#8,d2
	and.w	#$f,d2
	sub.w	fade_coef,d2
	bpl	no_zero3
	clr.w	d2
no_zero3:
	and.w	#$0ff,d1
	lsl	#8,d2
	or.w	d2,d1
	Rts
;---------------------------------------------------------------
	dc.w	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
motif_depart:	 
	dc.w	0,0,0,0,0,0,0,0,0
	dc.w	$0,$101,$202,$303,$404,$505,$606,$707,$808,$909,$a0a,$b0b
	dc.w	$c0c,$d0d,$e0e,$f0f
	dc.w	$f1f,$f2f,$f3f,$f4f,$f5f,$f6f,$f7f,$f8f,$f9f,$faf,$fbe,$fcd
	dc.w	$fed,$ffc,$fec,$fdb,$fcb,$ebb,$dab,$cbb,$bba,$aba,$9c9,$8c7
	dc.w	$7c5,$6d3,$5c2,$4b2,$3a2,$392,$382,$372,$363,$363,$353
	dc.w	$242,$131,$020,$010
	dc.w	$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0
;---------------------------------------------------------------
Construit_damier:
	lea	motif,a0
	lea	motif_depart,a1
	clr.l	d2
	clr.l	d4
	
	move.w	#80,d1

Cons_c2:
	move.l	a0,a2

	lea	motif_depart,a1
	add.l	d4,a1	

	add.l	#2,d4

	add.w	#1,d2
	move.w	d2,d3
Cons_c1:
	move.w	-(a1),(a2)+
	dbra	d3,cons_c1

	add.l	#120,a0

	dbra	d1,cons_c2

	Rts
;---------------------------------------------------------------
Put_plans:

	lea	pt1,a0
	move.l	#damier,d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	lea	pt2,a0
	move.l	#damier+[137*40],d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	lea	pt3,a0
	move.l	#damier+[137*40*2],d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	lea	pt4,a0
	move.l	#damier+[137*40*3],d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	lea	pt5,a0
	move.l	#damier+[137*40*4],d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	Rts
;---------------------------------------------------------------
COPP:		DC.L	$01000200,$00960020
		DC.L	$01800000,$01080000,$010a0000
		dc.l	$01040000

start=$99+22

		Dc.b	start-1,$01,$FF,$FE
pt1:		dc.l	$00e00000,$00e20000
pt2:		dc.l	$00e40000,$00e60000
pt3:		dc.l	$00e80000,$00ea0000
pt4:		dc.l	$00ec0000,$00ee0000
pt5:		dc.l	$00f00000,$00f20000
		Dc.l	$01005200

l1:		Dc.b	start,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

l2:		Dc.b	start+1,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

l3:		Dc.b	start+2,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$019000d0,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00400,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

l4:		Dc.b	start+3,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

l5:		Dc.b	start+5,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

l6:		Dc.b	start+8,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

l7:		Dc.b	start+11,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

l8:		Dc.b	start+17,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

l9:		Dc.b	start+26,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

l10:		Dc.b	start+38,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00400,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

l11:		Dc.b	start+57,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

		dc.b	$ff,$df,$ff,$fe
l12:		Dc.b	5,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

l13:		Dc.b	41,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

l14:		Dc.b	$36,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

l15:		Dc.b	$37,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000

lfin:		Dc.b	$38,$01,$FF,$FE
		Dc.l	$01820000,$01840000,$01860000,$01880000,$018a0000
		Dc.l	$018c0000,$018e0000,$01900000,$01920000,$01940000
		Dc.l	$01960000,$01980000,$019a0000,$019c0000,$019e0000
		Dc.l	$01a00000,$01a20000,$01a40000,$01a60000,$01a80000
		Dc.l	$01aa0000,$01ac0000,$01ae0000,$01b00000,$01b20000
		Dc.l	$01b40000,$01b60000,$01b80000,$01ba0000,$01bc0000
		dc.l	$01000200
		DC.L	$009C8010,$FFFFFFFE	; END COPPER
;---------------------------------------------------------------
Table_couleur:	blk.w	[30*2]*16
Damier:		blk.b	[137*40]*5


>extern		"df1:s_damier/damier1.bt",damier

* END *
